/* strp + 2lf, Copyright (c) 1996, 1998 
 * by Eddie Buckley <eddie@sjfn.nb.ca>
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  No representations are made about the suitability of this
 * software for any purpose.  It is provided "as is" without express or 
 * implied warranty.
 *
 * I know the code needs to be cleaned up a little, and please don't
 * give me any grief about the goto's!
 */

#define	COMMON

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include "strp.h"

char    *progname;

void
try(void)
{
    fprintf(stderr, "Try `%s -h' for more information.\n", progname);
}

void
usage(void)
{
    fprintf(stderr, "Usage: %s [OPTION] [FILE]...\n", progname);
}


int
main(int argc, char *argv[] )
{
    extern char *arg_chars;
    extern char *usage_chars;

    extern char	*optarg;
    extern int	optind, opterr, optopt;

    extern int	isdir(char *filename);

    char	opt, arg, *tmpfname;
    char	lch;
    int 	i, j, count, posn;

/* This assumes a possible file conatining only line breaks where double the
 * input characters would be output: */
    char	inbuff[MAXBUFF], outbuff[MAXBUFF*2];

    FILE	*infile, *tmpfile;
    extern	int 	(*func_p)(char curr, char last, char *buff, int posn);
    int 	numb;

    progname = (rindex(argv[0], '/') ? (rindex(argv[0], '/')+1) : argv[0]);

    if(argc < 2)  {
        usage();
        try();
        exit(1);
    }

    for(arg = '\0'; opt != EOF; )
    {
        if((opt = getopt(argc, argv, arg_chars)) == '?')
        {
            fprintf(stderr, "usage %s %s\n", progname, usage_chars );
            exit(1);
        }
        if(arg == '\0')  arg = opt;
    }

    lch = arg_parse(arg);

    if(argv[optind] == NULL)  goto NOFILES;
    for(i = optind; i < argc; i++)
    {
        if((argv[i][0] == '-') && (argv[i][1] == 0))
        {
            j = -1;
            goto STDIN_STDOUT;
        }
        else
        {
            if((access(argv[i], W_OK)))
            {
              if(errno == EACCES)
              {
                fprintf(stderr, "%s: %s: %s\n", progname, argv[i],
                                                            strerror(errno) );
                continue;
              }
              else if(errno == ENOENT)
              {
                fprintf(stderr, "%s: %s: %s\n", progname, argv[i],
                                                            strerror(errno) );
                continue;
              }
            }
            if(isdir(argv[i]))
            {
                fprintf(stderr, "%s: %s: %s\n", progname, argv[i],
                                                            strerror(EISDIR) );
                continue;
            }
        }
        if((infile = fopen(argv[i], "rb"))==NULL)
        {
            fprintf(stderr, "Error opening file: %s \n", argv[i]);
            continue;
        }

        tmpfname = tempnam(NULL, "strp");

#ifdef	DEBUG
	      printf(": %s\n", tmpfname);
#endif

        if((tmpfile = fopen(tmpfname, "wb"))==NULL)
        {
            fprintf(stderr, "Unable to create tempory file\n");
            continue;
        }
        posn = 0;
        while(!feof(infile))
        {
            count = fread(&inbuff, 1, MAXBUFF, infile);

#ifdef	DEBUG
            fprintf(stderr, "read count = %d\n", count);
#endif

            for(j=0; j<count; j++)  {
                posn = func_p( *(inbuff+j), lch, outbuff, posn);
                lch = *(inbuff+j);
            }

            numb = fwrite(outbuff, 1, posn, tmpfile);
            posn = 0;

#ifdef	DEBUG
        fprintf(stderr, "write count a = %d\n", numb);
#endif

        }

        fclose(infile);
        fclose(tmpfile);

        if((rename(tmpfname, argv[i])== -1) && errno == EXDEV)
        {

#ifdef	DEBUG
            fprintf(stderr, "rename failed\n");
#endif

            if((tmpfile = fopen(tmpfname, "rb"))==NULL)  {
                fprintf(stderr, "Cannot open tempfile %s for reading\n",
                                                                tmpfname);
                if(remove(tmpfname))
                    fprintf(stderr, "removal of temp file failed\n");
                continue;
            }
            if((infile = fopen(argv[i], "wb"))==NULL)
            {
                fprintf(stderr, "Cannot open file: %s for writing\n", argv[i]);
                if(remove(tmpfname))
                    fprintf(stderr, "removal of temp file failed\n");
                continue;
            }
            while(!feof(tmpfile))
            {
                count = fread(&inbuff, 1, MAXBUFF, tmpfile);
                fwrite(inbuff, 1, count, infile);
            }
            fclose(tmpfile);
            fclose(infile);
            if(remove(tmpfname))
                fprintf(stderr, "removal of temp file failed\n"); 
        }
        free(tmpfname);
  CONT:
    }

    exit(0);

  NOFILES:
  STDIN_STDOUT:
	/* This bit is for standard input and standard output as files */
	fprintf(stderr, "No files\n");

	/* This is just a quick hack to test the conversion functions,
	   it needs to be re-done big time.
	 */

      posn = 0;

    for(;;)  {
        char	ch;

        scanf("%c", &ch);
        if( (posn > MAXBUFF-1) || (feof(stdin)) )
        {
            for(i=0; i<posn; i++)
                printf("%c", *(outbuff+i));
            if(feof(stdin))  break;
            posn = 0;
        }
        posn = func_p(ch, lch, outbuff, posn);
    }
    if(j == -1)
        goto CONT;
    else
        exit(0);

}
